% Distributions
clear;   
% ---- Point process (Inter-Success Interval) Poisson Process ----
n = 1;
p = 0.01;   % 0 < p < 0.5
samples = 100000;
run=1:samples;
expectation = ones(1,samples);
stdev = ones(1,samples);
success = fix(2*(rand(n,samples)-(0.5-p)));
headTimes = find(success==1);
isi = headTimes(2:length(headTimes)) - headTimes(1:length(headTimes)-1);
addColumns = ones(1,n);
randomSample = addColumns*success;
stdev = std(randomSample)*stdev;
expectation(1,:) = mean(randomSample(1,:));
figure(1)
    range = n + 1;
	plot(randomSample, '*')
    hold on
    plot(expectation, '-r')
    plot(expectation+stdev, '--g')
    plot(expectation-stdev, '--g')
    hold off
    axis([1 samples -1 range]);
    
%binomial distribution
   k = [0:1:n];
   C_nk = gamma(n+1)./(gamma(k+1).*gamma(n-k+1) );
   Pk = C_nk.*p.^k.*(1-p).^(n - k);
%Pk = binopdf(k,n,p);

range = n + 1;
k =0:n;
figure(2)
    binWidth = 1;
    x = -range:binWidth:range;
    histogram = histc(randomSample, x);
    bar(x, histogram/samples)
    hold on
    stem(k,Pk, 'r')
    hold off
    xlim([-1 range])
    title('Probability distribution')       
    xlabel('k')
    ylabel('P(k)')
    
figure(3)
    binWidth = 1;
    x = -0:binWidth:samples;
    histogram = histc(isi, x);
    bar(x, histogram/samples)
    xlim([-1 100])
