% Markov Process - Random Walk

clear
N = 30;                              % number of states (N is odd)
p = 0.2;                            % up-step probability
q = 1-p;                            % down-step probability
max_n = 100;                         % maximum number of steps
P = circshift(eye(N), [0, -1])*p + circshift(eye(N), [0, 1])*q; % transition matrix
%P(1,N) = 0;                        % absorbing top boundry
%P(N,1) = 0;                        % absorbing bottom boundry
e_0 = zeros(N,1);                   % initialize initial-state vector
e_0(round((N+1)/2)) = 1;            % set initial-state vector
states = zeros(N,max_n);            % initialize state matrix
% --- Loop through walk -------
for n=1:max_n
%   n = 5;
    pn = P^n;
    e_n = pn*e_0;
    states(:,n) = e_n;
end
figure(1)
    imagesc (states);
    colorbar;
    
finalProb = (states(:,max_n) + states(:,max_n-1));
figure(2)
    plot (finalProb);
    title('Final state probability')       
    xlabel('state')
    ylabel('probability')
    ylim([0 0.5])
